Index: /palm/trunk/UTIL/inifor/src/transform.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/transform.f90	(revision 3394)
+++ /palm/trunk/UTIL/inifor/src/transform.f90	(revision 3395)
@@ -26,4 +26,11 @@
 ! -----------------
 ! $Id$
+! Switched addressing of averaging regions from index bounds to list of columns
+! Added routines for the computation of geostrophic winds including:
+!    - the downward extrapolation of density (linear) and
+!    - pressure (hydrostatic equation) and
+!    - rotation of geostrophic wind components to PALM frame of reference
+! 
+! 3183 2018-07-27 14:25:55Z suehring
 ! Introduced new PALM grid stretching
 ! Removed unnecessary subroutine parameters
@@ -51,5 +58,5 @@
     USE control
     USE defs,                                                                  &
-        ONLY: TO_DEGREES, TO_RADIANS, PI, dp
+        ONLY: G, TO_DEGREES, TO_RADIANS, PI, dp
     USE types
     USE util,                                                                  &       
@@ -176,30 +183,32 @@
 
 
-    SUBROUTINE average_2d(in_arr, out_arr, imin, imax, jmin, jmax)
-       REAL(dp), INTENT(IN)  ::  in_arr(0:,0:,0:)
-       REAL(dp), INTENT(OUT) ::  out_arr(0:)
-       INTEGER, INTENT(IN)   ::  imin, imax, jmin, jmax
-
-       INTEGER  ::  i, j, k
+    SUBROUTINE average_2d(in_arr, out_arr, ii, jj)
+       REAL(dp), INTENT(IN)              ::  in_arr(0:,0:,0:)
+       REAL(dp), INTENT(OUT)             ::  out_arr(0:)
+       INTEGER, INTENT(IN), DIMENSION(:) ::  ii, jj
+
+       INTEGER  ::  i, j, k, l
        REAL(dp) ::  ni
-       
-       IF (imin < 0)  CALL abort('average_2d', "imin < 0.")
-       IF (jmin < 0)  CALL abort('average_2d', "jmin < 0.")
-       IF (imax > UBOUND(in_arr, 1))  CALL abort('average_2d', "imax out of i bound.")
-       IF (jmax > UBOUND(in_arr, 2))  CALL abort('average_2d', "jmax out of j bound.")
+
+       IF (SIZE(ii) .NE. SIZE(jj))  THEN
+          message = "Length of 'ii' and 'jj' index lists do not match." //     &
+             NEW_LINE(' ') // "ii has " // str(SIZE(ii)) // " elements, " //        &
+             NEW_LINE(' ') // "jj has " // str(SIZE(jj)) // "."
+          CALL abort('average_2d', message)
+       END IF
 
        DO k = 0, UBOUND(out_arr, 1)
 
           out_arr(k) = 0.0_dp
-          DO j = jmin, jmax
-          DO i = imin, imax
-             out_arr(k) = out_arr(k) + in_arr(i, j, k)
+          DO l = 1, UBOUND(ii, 1)
+             i = ii(l)
+             j = jj(l)
+             out_arr(k) = out_arr(k) +&
+                         in_arr(i, j, k)
           END DO
-          END DO
-
-       END DO
-   
-       ! devide by number of grid points
-       ni = 1.0_dp / ( (imax - imin + 1) * (jmax - jmin + 1) )
+
+       END DO
+
+       ni = 1.0_dp / SIZE(ii)
        out_arr(:) = out_arr(:) * ni
 
@@ -212,14 +221,14 @@
        REAL(dp), DIMENSION(:,:,:), INTENT(OUT) ::  palm_array
        REAL(dp), DIMENSION(:,:,:), ALLOCATABLE ::  intermediate_array
-       INTEGER ::  nx, ny, nz
+       INTEGER ::  nx, ny, nlev
 
        nx = palm_intermediate % nx
        ny = palm_intermediate % ny
-       nz = palm_intermediate % nz ! nlev
+       nlev = palm_intermediate % nz ! nlev
 
        ! Interpolate from COSMO-DE to intermediate grid. Allocating with one
        ! less point in the vertical, since scalars like T have 50 instead of 51
        ! points in COSMO-DE.
-       ALLOCATE(intermediate_array(0:nx, 0:ny, 0:nz-1)) !
+       ALLOCATE(intermediate_array(0:nx, 0:ny, 0:nlev-1)) !
 
        CALL interpolate_2d(source_array, intermediate_array, palm_intermediate)
@@ -234,29 +243,144 @@
 
 
-    SUBROUTINE average_profile(source_array, profile_array, imin, imax, jmin, jmax,&
-                               palm_intermediate, palm_grid)
-       TYPE(grid_definition), INTENT(IN)          ::  palm_intermediate, palm_grid
+    SUBROUTINE average_profile(source_array, profile_array, avg_grid)
+       TYPE(grid_definition), INTENT(IN)          ::  avg_grid
        REAL(dp), DIMENSION(:,:,:), INTENT(IN)     ::  source_array
-       INTEGER, INTENT(IN)                        ::  imin, imax, jmin, jmax
-       REAL(dp), DIMENSION(0:,0:,0:), INTENT(OUT) ::  profile_array
-       REAL(dp), DIMENSION(:,:,:), ALLOCATABLE    ::  intermediate_array
-       INTEGER                                    ::  nx, ny, nz
-
-       nx = palm_intermediate % nx
-       ny = palm_intermediate % ny
-       nz = palm_intermediate % nz
-       ALLOCATE(intermediate_array(0:nx, 0:ny, 0:nz-1))
-       intermediate_array(:,:,:) = 0.0_dp
-
-       ! average input array to intermediate profile
-       CALL average_2d(source_array, intermediate_array(0,0,:), imin, imax, jmin, jmax)
-
-       ! vertically interpolate to ouput array
-       CALL interpolate_1d(intermediate_array, profile_array, palm_grid)
-
-       DEALLOCATE(intermediate_array)
+       REAL(dp), DIMENSION(:), INTENT(OUT)        ::  profile_array
+
+       INTEGER ::  i_source, j_source, k_profile, k_source, l, m
+
+       REAL ::  ni_columns
+
+       profile_array(:) = 0.0_dp
+
+       DO l = 1, avg_grid % n_columns
+          i_source = avg_grid % iii(l)
+          j_source = avg_grid % jjj(l)
+
+          DO k_profile = avg_grid % k_min, UBOUND(profile_array, 1) ! PALM levels
+
+             DO m = 1, 2 ! vertical interpolation neighbours
+
+                k_source = avg_grid % kkk(l, k_profile, m)
+
+                profile_array(k_profile) = profile_array(k_profile)    &
+                   + avg_grid % w(l, k_profile, m)                             &
+                   * source_array(i_source, j_source, k_source)
+
+             END DO ! m, vertical interpolation neighbours
+
+          END DO    ! k_profile, PALM levels
+
+       END DO       ! l, horizontal neighbours
+
+       ni_columns = 1.0_dp / avg_grid % n_columns
+       profile_array(:) = profile_array(:) * ni_columns
+
+       ! Extrapolate constant to the bottom
+       profile_array(1:avg_grid % k_min-1) = profile_array(avg_grid % k_min)
 
     END SUBROUTINE average_profile
 
+
+    SUBROUTINE extrapolate_density(rho, avg_grid)
+       REAL(dp), DIMENSION(:), INTENT(INOUT) ::  rho
+       TYPE(grid_definition), INTENT(IN)     ::  avg_grid
+
+       REAL(dp) ::  drhodz, dz, zk, rhok
+       INTEGER  ::  k_min
+
+       k_min  = avg_grid % k_min
+       zk     = avg_grid % z(k_min)
+       rhok   = rho(k_min)
+       dz     = avg_grid % z(k_min + 1) - avg_grid % z(k_min)
+       drhodz = (rho(k_min + 1) - rho(k_min)) / dz
+
+       rho(1:k_min-1) = rhok + drhodz * (avg_grid % z(1:k_min-1) - zk)
+
+    END SUBROUTINE extrapolate_density
+
+
+    SUBROUTINE extrapolate_pressure(p, rho, avg_grid)
+       REAL(dp), DIMENSION(:), INTENT(IN)    ::  rho
+       REAL(dp), DIMENSION(:), INTENT(INOUT) ::  p
+       TYPE(grid_definition), INTENT(IN)     ::  avg_grid
+
+       REAL(dp) ::  drhodz, dz, zk, rhok
+       INTEGER  ::  k, k_min
+
+       k_min = avg_grid % k_min
+       zk    = avg_grid % z(k_min)
+       rhok  = rho(k_min)
+       dz    = avg_grid % z(k_min + 1) - avg_grid % z(k_min)
+       drhodz = 0.5_dp * (rho(k_min + 1) - rho(k_min)) / dz
+
+       DO k = 1, k_min-1
+          p(k) = constant_density_pressure(p(k_min), zk, rhok, drhodz,         &
+                                           avg_grid % z(k), G)
+       END DO
+
+    END SUBROUTINE extrapolate_pressure
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Takes the averaged pressure profile <p> and sets the lowest entry to the
+!> extrapolated pressure at the surface.
+!------------------------------------------------------------------------------!
+    SUBROUTINE get_surface_pressure(p, rho, avg_grid)
+       REAL(dp), DIMENSION(:), INTENT(IN)    ::  rho
+       REAL(dp), DIMENSION(:), INTENT(INOUT) ::  p
+       TYPE(grid_definition), INTENT(IN)     ::  avg_grid
+
+       REAL(dp) ::  drhodz, dz, zk, rhok
+       INTEGER  ::  k, k_min
+
+       k_min = avg_grid % k_min
+       zk    = avg_grid % z(k_min)
+       rhok  = rho(k_min)
+       dz    = avg_grid % z(k_min + 1) - avg_grid % z(k_min)
+       drhodz = 0.5_dp * (rho(k_min + 1) - rho(k_min)) / dz
+
+       p(1) = constant_density_pressure(p(k_min), zk, rhok, drhodz,            &
+                                        0.0, G)
+
+    END SUBROUTINE get_surface_pressure
+
+
+    FUNCTION constant_density_pressure(pk, zk, rhok, drhodz, z, g)  RESULT(p)
+
+       REAL(dp), INTENT(IN)  ::  pk, zk, rhok, drhodz, g, z
+       REAL(dp) ::  p
+
+       p = pk + ( zk - z ) * g * ( rhok + 0.5*drhodz * (zk - z) )
+
+    END FUNCTION constant_density_pressure
+
+!-----------------------------------------------------------------------------!
+! Description:
+! -----------
+!> This routine computes profiles of the two geostrophic wind components ug and
+!> vg.
+!-----------------------------------------------------------------------------!
+    SUBROUTINE geostrophic_winds(p_north, p_south, p_east, p_west, rho, f3,    &
+                                 Lx, Ly, phi_n, lam_n, phi_g, lam_g, ug, vg)
+
+    REAL(dp), DIMENSION(:), INTENT(IN)  ::  p_north, p_south, p_east, p_west,  &
+                                            rho
+    REAL(dp), INTENT(IN)                ::  f3, Lx, Ly, phi_n, lam_n, phi_g, lam_g
+    REAL(dp), DIMENSION(:), INTENT(OUT) ::  ug, vg
+    REAL(dp)                            ::  facx, facy
+
+    facx = 1.0_dp / (Lx * f3)
+    facy = 1.0_dp / (Ly * f3)
+    ug(:) = - facy / rho(:) * (p_north(:) - p_south(:))
+    vg(:) =   facx / rho(:) * (p_east(:) - p_west(:))
+
+    CALL rotate_vector_field(                                                  &
+       ug, vg, angle = meridian_convergence_rotated(phi_n, lam_n, phi_g, lam_g)&
+    )
+
+    END SUBROUTINE geostrophic_winds
 
 
@@ -419,4 +543,54 @@
        
 
+    SUBROUTINE rotate_vector_field(x, y, angle)
+       REAL(dp), DIMENSION(:), INTENT(INOUT) :: x, y  !< x and y coodrinate in arbitrary units
+       REAL(dp), INTENT(IN)                  :: angle !< rotation angle [deg]
+
+       INTEGER  :: i
+       REAL(dp) :: sine, cosine, v_rot(2), rotation(2,2)
+
+       sine = SIN(angle * TO_RADIANS)
+       cosine = COS(angle * TO_RADIANS)
+       ! RESAHPE() fills columns first, so the rotation matrix becomes
+       !
+       ! rotation = [ cosine   -sine  ]
+       !            [  sine    cosine ]
+       rotation = RESHAPE( (/cosine, sine, -sine, cosine/), (/2, 2/) )
+
+       DO i = LBOUND(x, 1), UBOUND(x, 1)
+
+          v_rot(:) = MATMUL(rotation, (/x(i), y(i)/))
+
+          x(i) = v_rot(1)
+          y(i) = v_rot(2)
+
+       END DO
+
+    END SUBROUTINE rotate_vector_field
+
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> This routine computes the local meridian convergence between a rotated-pole
+!> and a geographical system using the Eq. (6) given in the DWD manual
+!> 
+!>    Baldauf et al. (2018), Beschreibung des operationelle KuÌrzestfrist-
+!>    vorhersagemodells COSMO-D2 und COSMO-D2-EPS und seiner Ausgabe in die
+!>    Datenbanken des DWD.
+!>    https://www.dwd.de/SharedDocs/downloads/DE/modelldokumentationen/nwv/cosmo_d2/cosmo_d2_dbbeschr_aktuell.pdf?__blob=publicationFile&v=2
+!>
+    FUNCTION meridian_convergence_rotated(phi_n, lam_n, phi_g, lam_g)          &
+       RESULT(delta)
+
+       REAL(dp), INTENT(IN) ::  phi_n, lam_n, phi_g, lam_g
+       REAL(dp)             ::  delta
+
+       delta = atan2( COS(phi_n) * SIN(lam_n - lam_g),                         &
+                      COS(phi_g) * SIN(phi_n) -                                &
+                      SIN(phi_g) * COS(phi_n) * COS(lam_n - lam_g) )
+
+    END FUNCTION meridian_convergence_rotated
 
 !------------------------------------------------------------------------------!
@@ -512,5 +686,6 @@
 
     
-    SUBROUTINE find_vertical_neighbours_and_weights(palm_grid, palm_intermediate)
+    SUBROUTINE find_vertical_neighbours_and_weights_interp( palm_grid,         &
+                                                            palm_intermediate )
        TYPE(grid_definition), INTENT(INOUT) ::  palm_grid
        TYPE(grid_definition), INTENT(IN)    ::  palm_intermediate
@@ -528,6 +703,6 @@
 
        ! in each column of the fine grid, find vertical neighbours of every cell
+       DO j = 0, ny
        DO i = 0, nx
-       DO j = 0, ny
 
           k_intermediate = 0
@@ -536,5 +711,5 @@
           column_top  = palm_intermediate % h(i,j,nlev)
 
-          ! scan through palm_grid column until and set neighbour indices in
+          ! scan through palm_grid column and set neighbour indices in
           ! case current_height is either below column_base, in the current
           ! cell, or above column_top. Keep increasing current cell index until
@@ -580,4 +755,101 @@
                    h_top    = palm_intermediate % h(i,j,k_intermediate+1)
                    h_bottom = palm_intermediate % h(i,j,k_intermediate)
+                   point_is_in_current_cell = (                                &
+                      current_height >= h_bottom .AND.                         &
+                      current_height <  h_top                                  &
+                   )
+                END DO
+
+                IF (k_intermediate > nlev-1)  THEN
+                   message = "Index " // TRIM(str(k_intermediate)) //          &
+                             " is above intermediate grid range."
+                   CALL abort('find_vertical_neighbours', message)
+                END IF
+   
+                palm_grid % kk(i,j,k,1) = k_intermediate
+                palm_grid % kk(i,j,k,2) = k_intermediate + 1
+
+                ! copmute vertical weights
+                weight = (h_top - current_height) / (h_top - h_bottom)
+                palm_grid % w_verti(i,j,k,1) = weight
+                palm_grid % w_verti(i,j,k,2) = 1.0_dp - weight
+             END IF
+
+          END DO
+
+       END DO
+       END DO
+
+    END SUBROUTINE find_vertical_neighbours_and_weights_interp
+
+
+    SUBROUTINE find_vertical_neighbours_and_weights_average( avg_grid )
+       TYPE(grid_definition), INTENT(INOUT) ::  avg_grid
+
+       INTEGER  ::  i, j, k_palm, k_intermediate, l, nlev
+       LOGICAL  ::  point_is_below_grid, point_is_above_grid,                  &
+                    point_is_in_current_cell
+       REAL(dp) ::  current_height, column_base, column_top, h_top, h_bottom,  &
+                    weight
+
+
+       avg_grid % k_min = LBOUND(avg_grid % z, 1)
+
+       nlev = SIZE(avg_grid % cosmo_h, 3)
+
+       ! in each column of the fine grid, find vertical neighbours of every cell
+       DO l = 1, avg_grid % n_columns
+
+          i = avg_grid % iii(l)
+          j = avg_grid % jjj(l)
+
+          column_base = avg_grid % cosmo_h(i,j,1)
+          column_top  = avg_grid % cosmo_h(i,j,nlev)
+
+          ! scan through avg_grid column until and set neighbour indices in
+          ! case current_height is either below column_base, in the current
+          ! cell, or above column_top. Keep increasing current cell index until
+          ! the current cell overlaps with the current_height.
+          k_intermediate = 1 !avg_grid % cosmo_h is indezed 1-based.
+          DO k_palm = 1, avg_grid % nz
+
+             ! Memorize the top and bottom boundaries of the coarse cell and the
+             ! current height within it
+             current_height = avg_grid % z(k_palm) + avg_grid % z0
+             h_top    = avg_grid % cosmo_h(i,j,k_intermediate+1)
+             h_bottom = avg_grid % cosmo_h(i,j,k_intermediate)
+
+             point_is_above_grid = (current_height > column_top) !22000m, very unlikely
+             point_is_below_grid = (current_height < column_base)
+
+             point_is_in_current_cell = (                                      &
+                current_height >= h_bottom .AND.                               &
+                current_height <  h_top                                        &
+             )
+
+             ! set default weights
+             avg_grid % w(l,k_palm,1:2) = 0.0_dp
+
+             IF (point_is_above_grid)  THEN
+
+                avg_grid % kkk(l,k_palm,1:2) = nlev
+                avg_grid % w(l,k_palm,1:2) = - 2.0_dp
+
+                message = "PALM-4U grid extends above COSMO-DE model top."
+                CALL abort('find_vertical_neighbours_and_weights_average', message)
+
+             ELSE IF (point_is_below_grid)  THEN
+
+                avg_grid % kkk(l,k_palm,1:2) = 0
+                avg_grid % w(l,k_palm,1:2) = - 2.0_dp
+                avg_grid % k_min = MAX(k_palm + 1, avg_grid % k_min)
+             ELSE
+                ! cycle through intermediate levels until current
+                ! intermediate-grid cell overlaps with current_height
+                DO WHILE (.NOT. point_is_in_current_cell .AND. k_intermediate <= nlev-1)
+                   k_intermediate = k_intermediate + 1
+
+                   h_top    = avg_grid % cosmo_h(i,j,k_intermediate+1)
+                   h_bottom = avg_grid % cosmo_h(i,j,k_intermediate)
                    point_is_in_current_cell = (                                &
                       current_height >= h_bottom .AND.                         &
@@ -594,19 +866,17 @@
                 END IF
    
-                palm_grid % kk(i,j,k,1) = k_intermediate
-                palm_grid % kk(i,j,k,2) = k_intermediate + 1
+                avg_grid % kkk(l,k_palm,1) = k_intermediate
+                avg_grid % kkk(l,k_palm,2) = k_intermediate + 1
 
                 ! copmute vertical weights
                 weight = (h_top - current_height) / (h_top - h_bottom)
-                palm_grid % w_verti(i,j,k,1) = weight
-                palm_grid % w_verti(i,j,k,2) = 1.0_dp - weight
+                avg_grid % w(l,k_palm,1) = weight
+                avg_grid % w(l,k_palm,2) = 1.0_dp - weight
              END IF
 
-          END DO
-
-       END DO
-       END DO
-
-    END SUBROUTINE find_vertical_neighbours_and_weights
+          END DO ! k, PALM levels
+       END DO ! l, averaging columns
+ 
+    END SUBROUTINE find_vertical_neighbours_and_weights_average
 
 !------------------------------------------------------------------------------!
Index: /palm/trunk/UTIL/inifor/src/types.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/types.f90	(revision 3394)
+++ /palm/trunk/UTIL/inifor/src/types.f90	(revision 3395)
@@ -26,4 +26,11 @@
 ! -----------------
 ! $Id$
+! Added *_is_set LOGICALs to inifor_config type to indicate option invocation
+!     from the command-line 
+! Added 1D index vertical weights lists to support addressing averaging regions
+!     by list of columns instead of index bounds
+! 
+! 
+! 3183 2018-07-27 14:25:55Z suehring
 ! Introduced new PALM grid stretching:
 ! - Converted vertical grid_definition coordinte variables to pointers
@@ -66,8 +73,10 @@
 
     CHARACTER(LEN=SNAME) ::  flow_prefix          !< Prefix of flow input files, e.g. 'laf' for COSMO-DE analyses
+    CHARACTER(LEN=SNAME) ::  input_prefix         !< Prefix of all input files, e.g. 'laf' for COSMO-DE analyses
+    CHARACTER(LEN=SNAME) ::  radiation_prefix     !< Prefix of radiation input files, e.g 'laf' for COSMO-DE analyses
     CHARACTER(LEN=SNAME) ::  soil_prefix          !< Prefix of soil input files, e.g. 'laf' for COSMO-DE analyses
-    CHARACTER(LEN=SNAME) ::  radiation_prefix     !< Prefix of radiation input files, e.g 'laf' for COSMO-DE analyses
     CHARACTER(LEN=SNAME) ::  soilmoisture_prefix  !< Prefix of input files for soil moisture spin-up, e.g 'laf' for COSMO-DE analyses
 
+    CHARACTER(LEN=SNAME) ::  averaging_mode
     CHARACTER(LEN=SNAME) ::  bc_mode
     CHARACTER(LEN=SNAME) ::  ic_mode
@@ -77,15 +86,34 @@
     REAL(dp)             ::  ug
     REAL(dp)             ::  vg
-    REAL(dp)             ::  z0 !< Elevation of the PALM-4U domain above sea level [m]
+    REAL(dp)             ::  z0                   !< Elevation of the PALM-4U domain above sea level [m]
+    REAL(dp)             ::  averaging_angle      !< latitudal and longitudal width of averaging regions [deg]
+    
+
+    LOGICAL              ::  debug
+    LOGICAL              ::  p0_is_set
+    LOGICAL              ::  ug_is_set
+    LOGICAL              ::  vg_is_set
+    LOGICAL              ::  flow_prefix_is_set          !< 
+    LOGICAL              ::  input_prefix_is_set         !< 
+    LOGICAL              ::  radiation_prefix_is_set     !< 
+    LOGICAL              ::  soil_prefix_is_set          !< 
+    LOGICAL              ::  soilmoisture_prefix_is_set  !< 
  END TYPE inifor_config
 
  TYPE grid_definition
     CHARACTER(LEN=SNAME)  ::  name(3)       !< names of the grid dimensions, e.g. (/'x', 'y', 'z'/) or (/'latitude', 'longitude', 'height'/)
+    CHARACTER(LEN=SNAME)  ::  kind          !< names of the grid dimensions, e.g. (/'x', 'y', 'z'/) or (/'latitude', 'longitude', 'height'/)
+    INTEGER               ::  k_min         !< Index of lowest PALM grid level that is not cut by local COSMO orography; vertically separates interpolation and extrapolation region.
     INTEGER               ::  nx            !< number of gridpoints in the first dimension
     INTEGER               ::  ny            !< number of gridpoints in the second dimension
-    INTEGER               ::  nz            !< number of gridpoints in the third dimension
+    INTEGER               ::  nz            !< number of gridpoints in the third dimension, used for PALM points
+    INTEGER               ::  nlev          !< number of COSMO grid levels
+    INTEGER               ::  n_columns     !< number of averaging columns of the source grid 
     INTEGER, ALLOCATABLE  ::  ii(:,:,:)     !< Given a point (i,j,k) in the PALM-4U grid, ii(i,j,l) gives the x index of the l'th horizontl neighbour on the COSMO-DE grid.
     INTEGER, ALLOCATABLE  ::  jj(:,:,:)     !< Given a point (i,j,k) in the PALM-4U grid, jj(i,j,l) gives the y index of the l'th horizontl neighbour on the COSMO-DE grid.
     INTEGER, ALLOCATABLE  ::  kk(:,:,:,:)   !< Given a point (i,j,k) in the PALM-4U grid, kk(i,j,k,l) gives the z index of the l'th vertical neighbour in the intermediate grid.
+    INTEGER, ALLOCATABLE  ::  iii(:)        !< profile averaging neighbour indices 
+    INTEGER, ALLOCATABLE  ::  jjj(:)        !< profile averaging neighbour indices 
+    INTEGER, ALLOCATABLE  ::  kkk(:,:,:)    !< indices of vertical interpolation neightbours, kkk(<source column>, <PALM k level>, <neighbour index>)
     REAL(dp)              ::  lx            !< domain length in the first dimension [m]
     REAL(dp)              ::  ly            !< domain length in the second dimension [m]
@@ -97,4 +125,5 @@
     REAL(dp), POINTER     ::  z(:)          !< coordinates of cell centers in z direction [m]
     REAL(dp), ALLOCATABLE ::  h(:,:,:)      !< heights grid point for intermediate grids [m]
+    REAL(dp), POINTER     ::  cosmo_h(:,:,:)!< pointer to appropriate COSMO level heights (scalar/w) [m]
     REAL(dp), POINTER     ::  hhl(:,:,:)    !< heights of half layers (cell faces) above sea level in COSMO-DE, read in from 
     REAL(dp), POINTER     ::  hfl(:,:,:)    !< heights of full layers (cell centres) above sea level in COSMO-DE, computed as arithmetic average of hhl
@@ -115,4 +144,5 @@
     REAL(dp), ALLOCATABLE ::  w_horiz(:,:,:)   !< weights for bilinear horizontal interpolation
     REAL(dp), ALLOCATABLE ::  w_verti(:,:,:,:) !< weights for linear vertical interpolation
+    REAL(dp), ALLOCATABLE ::  w(:,:,:)      !< vertical interpolation weights, w(<source_column>, <PALM k level>, <neighbour index>) [-]
  END TYPE grid_definition
 
@@ -150,8 +180,10 @@
     CHARACTER(LEN=SNAME)                  ::  task                      !< Processing task that generates this variable, e.g. 'interpolate_2d' or 'average profile'
     LOGICAL                               ::  to_be_processed = .FALSE. !< INIFOR flag indicating whether variable shall be processed
+    LOGICAL                               ::  is_internal = .FALSE.     !< INIFOR flag indicating whether variable shall be written to netCDF file (.FALSE.) or kept for later (.TRUE.)
     LOGICAL                               ::  is_read = .FALSE.         !< INIFOR flag indicating whether variable has been read
-    LOGICAL                               ::  is_upside_down  = .FALSE. !< INIFOR flag indicating whether variable shall be processed
+    LOGICAL                               ::  is_upside_down  = .FALSE. !< INIFOR flag indicating whether vertical dimension is reversed (typically the case with COSMO-DE atmospheric fields)
     TYPE(grid_definition), POINTER        ::  grid                      !< Pointer to the corresponding output grid
     TYPE(grid_definition), POINTER        ::  intermediate_grid         !< Pointer to the corresponding intermediate grid
+    TYPE(grid_definition), POINTER        ::  averaging_grid         !< Pointer to the corresponding intermediate grid
  END TYPE nc_var
 
@@ -159,5 +191,7 @@
  TYPE io_group                                          !< Input/Output group, groups together output variabels that share their input variables. For instance, all boundary surfaces and initialization fields of the potential temperature are base on T and p.
     INTEGER                          ::  nt             !< maximum number of output time steps across all output variables
-    INTEGER                          ::  nv             !< number of output variables
+    INTEGER                          ::  nv             !< number of netCDF output variables
+    INTEGER                          ::  n_inputs       !< number of input variables
+    INTEGER                          ::  n_output_quantities !< number of physical quantities required for computing netCDF output variables
     CHARACTER(LEN=SNAME)             ::  kind           !< kind of I/O group
     CHARACTER(LEN=PATH), ALLOCATABLE ::  in_files(:)    !< list of nt input files
Index: /palm/trunk/UTIL/inifor/src/util.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/util.f90	(revision 3394)
+++ /palm/trunk/UTIL/inifor/src/util.f90	(revision 3395)
@@ -26,4 +26,8 @@
 ! -----------------
 ! $Id$
+! New routines for computing potential temperature and moist air density
+! Increased number of digits in real-to-str conversion
+! 
+! 3183 2018-07-27 14:25:55Z suehring
 ! Improved real-to-string conversion
 ! 
@@ -48,4 +52,6 @@
     USE defs,                                                                  &
         ONLY :  dp, PI, DATE, SNAME
+    USE types,                                                                 &
+        ONLY :  grid_definition
 
     IMPLICIT NONE
@@ -281,4 +287,41 @@
 
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Converts the absolute temperature to the potential temperature in place using
+!> the identity a^b = e^(b ln(a)).
+!>
+!>     theta = T * (p_ref/p)^(R/c_p) = T * e^( R/c_p * ln(p_ref/p) )
+!------------------------------------------------------------------------------!
+    SUBROUTINE potential_temperature(t, p, p_ref, r, cp)
+       REAL(dp), DIMENSION(:,:,:), INTENT(INOUT) ::  t
+       REAL(dp), DIMENSION(:,:,:), INTENT(IN)    ::  p
+       REAL(dp), INTENT(IN)                      ::  p_ref, r, cp
+       REAL(dp)                                  ::  rcp
+
+       rcp = r/cp
+       t(:,:,:) =  t(:,:,:) * EXP( rcp * LOG(p_ref / p(:,:,:)) )
+
+    END SUBROUTINE potential_temperature
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the density in place of the given temperature (t_rho).
+!------------------------------------------------------------------------------!
+   SUBROUTINE moist_density(t_rho, p, qv, rd, rv)
+       REAL(dp), DIMENSION(:,:,:), INTENT(INOUT) ::  t_rho
+       REAL(dp), DIMENSION(:,:,:), INTENT(IN)    ::  p, qv
+       REAL(dp), INTENT(IN)                      ::  rd, rv
+
+       t_rho(:,:,:) = p(:,:,:) / (                                             &
+          (rv * qv(:,:,:) + rd * (1.0_dp - qv(:,:,:))) * t_rho(:,:,:)          &
+       )
+
+    END SUBROUTINE moist_density
+
+
     ! Convert a real number to a string in scientific notation
     ! showing four significant digits.
@@ -298,9 +341,9 @@
 
 
-    CHARACTER(LEN=12) FUNCTION real_to_str_f(val)
+    CHARACTER(LEN=16) FUNCTION real_to_str_f(val)
 
         REAL(dp), INTENT(IN) ::  val
 
-        WRITE(real_to_str_f, '(F12.4)') val
+        WRITE(real_to_str_f, '(F16.8)') val
         real_to_str_f = ADJUSTL(real_to_str_f)
 
